"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UP9HttpConnector = void 0;
var axios = require("axios");
var qs = require("querystring");
var UP9HttpConnector = /** @class */ (function () {
    function UP9HttpConnector(envUrl, clientId, clientSecret) {
        var _this = this;
        this.getTappingState = function () { return __awaiter(_this, void 0, void 0, function () {
            var response, _a, _b, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        _b = (_a = axios).get;
                        _c = [this.trccUrl + "/tapping/state"];
                        _d = {};
                        return [4 /*yield*/, this.getRequestHeader()];
                    case 1: return [4 /*yield*/, _b.apply(_a, _c.concat([(_d.headers = _e.sent(), _d)]))];
                    case 2:
                        response = _e.sent();
                        return [2 /*return*/, response.data];
                }
            });
        }); };
        this.renewToken = function () { return __awaiter(_this, void 0, void 0, function () {
            var body, tokenResponse;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        body = qs.stringify({ grant_type: 'client_credentials', client_id: this.clientId, client_secret: this.clientSecret });
                        return [4 /*yield*/, axios.post(this.tokenUrl, body, {
                                headers: {
                                    'Content-Type': 'application/x-www-form-urlencoded'
                                }
                            })];
                    case 1:
                        tokenResponse = (_a.sent()).data;
                        this.token = tokenResponse.access_token;
                        this.tokenExpiresAt = (+new Date()) + (tokenResponse.expires_in * 1000) - 10000;
                        return [2 /*return*/];
                }
            });
        }); };
        this.sendTrafficMessage = function (modelId, message) { return __awaiter(_this, void 0, void 0, function () {
            var messageBody, response, _a, _b, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        messageBody = {
                            type: 'collector',
                            data: message
                        };
                        _b = (_a = axios).post;
                        _c = [this.trafficDumperUrl + "/" + modelId, messageBody];
                        _d = {};
                        return [4 /*yield*/, this.getRequestHeader()];
                    case 1: return [4 /*yield*/, _b.apply(_a, _c.concat([(_d.headers = _e.sent(), _d)]))];
                    case 2:
                        response = _e.sent();
                        return [2 /*return*/, response.data];
                }
            });
        }); };
        this.getModelBlacklist = function (modelId) { return __awaiter(_this, void 0, void 0, function () {
            var response, _a, _b, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        _b = (_a = axios).get;
                        _c = [this.trccUrl + "/models/" + modelId + "/blacklist"];
                        _d = {};
                        return [4 /*yield*/, this.getRequestHeader()];
                    case 1: return [4 /*yield*/, _b.apply(_a, _c.concat([(_d.headers = _e.sent(), _d)]))];
                    case 2:
                        response = _e.sent();
                        return [2 /*return*/, response.data];
                }
            });
        }); };
        this.getRequestHeader = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(this.token == null || this.tokenExpiresAt > (+new Date()))) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.renewToken()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/, {
                            "Authorization": "bearer " + this.token
                        }];
                }
            });
        }); };
        this.envUrl = envUrl;
        this.trccUrl = "https://trcc." + envUrl;
        this.trafficDumperUrl = "https://traffic." + envUrl;
        this.clientId = clientId;
        this.clientSecret = clientSecret;
        this.tokenUrl = "https://auth." + this.envUrl + "/auth/realms/testr/protocol/openid-connect/token";
    }
    UP9HttpConnector.prototype.postTappingSource = function (tappingSourceId) {
        return __awaiter(this, void 0, void 0, function () {
            var url, response, _a, _b, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        url = this.trccUrl + "/tapping/state";
                        _b = (_a = axios).post;
                        _c = [url, { data: [{
                                        id: tappingSourceId,
                                        instancesCount: 1,
                                        instance_id: tappingSourceId,
                                        type: "nodejs-sdk"
                                    }] }];
                        _d = {};
                        return [4 /*yield*/, this.getRequestHeader()];
                    case 1: return [4 /*yield*/, _b.apply(_a, _c.concat([(_d.headers = _e.sent(), _d)]))];
                    case 2:
                        response = _e.sent();
                        return [2 /*return*/, response.data];
                }
            });
        });
    };
    return UP9HttpConnector;
}());
exports.UP9HttpConnector = UP9HttpConnector;
